import * as t from '@babel/types';

function index({ types: tt }) {
  return {
    visitor: {
      CallExpression(path, { opts }) {
        const callee = path.node.callee;
        const { callChains = [] } = opts;
        const [obj, ...fns] = callChains;
        if (tt.isIdentifier(callee, { name: obj })) {
          path.remove();
        }
        const isCallName = tt.isMemberExpression(callee) && tt.isIdentifier(callee.property) && fns.includes(callee.property.name);
        if (isIdentifierRecursive(callee, obj) && isCallName) {
          path.remove();
        }
      }
    }
  };
}
function isIdentifierRecursive(node, name) {
  if (!node)
    return false;
  if (t.isIdentifier(node, { name })) {
    return true;
  } else if (t.isMemberExpression(node)) {
    return isIdentifierRecursive(node.object, name);
  } else if (t.isCallExpression(node)) {
    return isIdentifierRecursive(node.callee, name);
  } else {
    return false;
  }
}

export { index as default };
